﻿using System;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Windows.DockManager.Events;

namespace XamDockManager
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Hidealllayout();
        }

        private bool LoadLayout(string profile)
        {
            try
            {
                using (var fileStream = new FileStream(System.IO.Path.GetTempPath() + profile + ".xml", FileMode.Open, FileAccess.Read))
                {
                    SamplexamDockManager.LoadLayout(fileStream);
                }
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return false;
            }
        }

        private void ContentPane_OptionsMenuOpening(object sender, PaneOptionsMenuOpeningEventArgs e)
        {
            e.Items.Clear();
        }

        private void Cmdnames_SelectedChanged(object sender, SelectionChangedEventArgs e)
        {
            Hidealllayout();
            ListBoxItem listBoxItem = e.AddedItems[0] as ListBoxItem;
            if (listBoxItem != null && LoadLayout(listBoxItem.Content as string))
            {
                return;
            }

            int selectedIndex = cmdnames.SelectedIndex;

            switch (selectedIndex)
            {
                case 0:
                    A.Visibility = Visibility.Visible;
                    B.Visibility = Visibility.Visible;
                    C.Visibility = Visibility.Visible;
                    D.Visibility = Visibility.Visible;
                    break; 
                case 1:
                    E.Visibility = Visibility.Visible;
                    F.Visibility = Visibility.Visible;
                    G.Visibility = Visibility.Visible;
                    D.Visibility = Visibility.Visible;
                    break; 
                case 2:
                    A.Visibility = Visibility.Visible;
                    B.Visibility = Visibility.Visible;
                    E.Visibility = Visibility.Visible;
                    F.Visibility = Visibility.Visible;
                    break;  
                case 3:
                    A.Visibility = Visibility.Visible;
                    B.Visibility = Visibility.Visible;
                    C.Visibility = Visibility.Visible;
                    D.Visibility = Visibility.Visible;
                    E.Visibility = Visibility.Visible;
                    F.Visibility = Visibility.Visible;
                    G.Visibility = Visibility.Visible;
                    break;
            }


        }

        private void Hidealllayout()
        {
            A.Visibility = Visibility.Collapsed;
            B.Visibility = Visibility.Collapsed;
            C.Visibility = Visibility.Collapsed;
            D.Visibility = Visibility.Collapsed;
            E.Visibility = Visibility.Collapsed;
            F.Visibility = Visibility.Collapsed;
            G.Visibility = Visibility.Collapsed;
        }

        private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {
            using (var fileStream = new FileStream(System.IO.Path.GetTempPath() + cmdnames.Text + ".xml", FileMode.Create, FileAccess.Write))
            {
                SamplexamDockManager.SaveLayout(fileStream);
            }
        }
    }
}
